library cossacks;

uses kol, data_classes_archive;

const
//  XORKey=$4E; //$78
  BlockSize=20000;
  FT_ARCHIVE=$0001;
  FT_IMAGESIMPLECUSTOMALETTE=$0003;
  INFO_1='   ';

var
  FData,FTemp,FMem: PStream;
  XORKey: Byte;

function MakeTree(Dir: string): Boolean;
begin
  Result := True;
  if Length(Dir) = 0 then Exit;
  if Dir[Length(Dir)]='\' then Delete(Dir,Length(Dir),1);
  if (Length(Dir) < 3) or DirectoryExists(Dir) or (ExtractFilePath(Dir) = Dir) then Exit; // avoid 'xyz:\' problem.
  Result := MakeTree(ExtractFilePath(Dir)) and CreateDir(Dir);
end;

procedure GetPluginInfo(var Title,Version,GameName,FilterGroupName,Filters,Extentions,Comments: PChar);
begin
  Title:=PChar('Cossacks Plugin');
  Version:=PChar('v1.01');
  GameName:=PChar('Cossacks');
  FilterGroupName:=PChar('Cossacks (*.gsc)');
  Filters:=PChar('*.gsc');
  Extentions:=PChar('GSC');
  Comments:=PChar('   GSC');
end;

function GetFileInfo(fName: PChar): Word;
var
  fStr,Extention: string;
begin
  fStr:=string(fName);
  Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
  if Extention='GSC' then Result:=FT_ARCHIVE;
end;

// ID 
function GetPluginID: Integer;
begin
  Result:=$0003;
end;

function GetFileAutoload(fName: PChar): Boolean;
begin
  Result:=False;
end;

procedure GetArchiveContent(fName: PChar; var fArchive: TArchive; fForm,fLabel,fProgressBar: PControl);
var
  TotalFiles,i,j,fTemp,SavePosition: LongInt;
  c: Char;
  fStr,Extention: string;
  Found,bTemp: Boolean;
begin
  fForm.Show;
  fLabel.Caption:=INFO_1+'(1/2)';
  fProgressBar.Progress:=0;
  fForm.Update;
  FData:=NewReadFileStream(fName);
  FData.Seek($0A,spBegin);
  FData.Read(TotalFiles,4);
  fArchive.TotalFiles:=TotalFiles;
  fArchive.ArchiveFullFileName:=string(fName);
  for i:=1 to TotalFiles do fArchive.Add('',0,0,0);
  fLabel.Caption:=INFO_1+'(2/2)';
  for i:=1 to TotalFiles do
  begin
    SavePosition:=$0E+(i-1)*$51;
    FData.Seek(SavePosition+4,spBegin);
    fStr:='';
    repeat
      FData.Read(c,1);
      if not (c=#$00) then fStr:=fStr+c;
    until c=#$00;
    fArchive.Items[i-1].Name:=fStr;
    Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
    if fArchive.CountFilters=0 then
    begin
      fArchive.AddFilter('*.'+LowerCase(Extention),Extention);
      fArchive.Items[i-1].FilterIndex:=fArchive.CountFilters-1;
    end
    else
    begin
      Found:=False;
      for j:=1 to fArchive.CountFilters do if fArchive.Filters[j-1].Extention=Extention then
      begin
        Found:=True;
        fArchive.Items[i-1].FilterIndex:=j-1;
        Break;
      end;
      if not Found then
      begin
        fArchive.AddFilter('*.'+LowerCase(Extention),Extention);
        fArchive.Items[i-1].FilterIndex:=fArchive.CountFilters-1;
      end;
    end;
    FData.Seek(SavePosition+4+64,spBegin);
    FData.Read(fTemp,4);
    fArchive.Items[i-1].Offset:=fTemp xor $FFFFFFFF;
    FData.Read(fTemp,4);
    fArchive.Items[i-1].SizeCompressed:=fTemp;
    FData.Seek(4,spCurrent);
    fArchive.Items[i-1].SizeReal:=fTemp;
    FData.Read(bTemp,1);
    fArchive.Items[i-1].FlagCompressed:=bTemp;
    fArchive.Items[i-1].FlagExtract:=False;
    fProgressBar.Progress:=Round(Int(100*(i/TotalFiles)));
  end;
  SavePosition:=FData.Position;
  for i:=1 to TotalFiles do fArchive.Items[i-1].Offset:=fArchive.Items[i-1].Offset+SavePosition;
  fArchive.FlagUseFilters:=True;
  FData.Free;
  fForm.Hide;
end;

procedure ExpandByte(B: Byte; var BT,BL: Byte);
begin
  BT:=B shr 7;
  BL:=B and $7F;
end;

procedure UnpackArchive(fName: PChar; fArchive: TArchive; var fForm,fLabel,fProgressBar: PControl);
var
  fBasePath,fFilePath,Extention: string;
  i,j,z: Integer;
  TotalBlocks,SavePosition: LongInt;
  Buffer,Buffer2: array[0..BlockSize-1]of byte;
  XOR1,XOR2,XOR3: Byte;
begin
  if fArchive.TotalFiles=0 then Exit;
  //  
  fForm.Show;
  fLabel.Caption:=' ...';
  fProgressBar.Progress:=0;
  fForm.Update;
  fBasePath:=fName;
  FData:=NewReadFileStream(fArchive.ArchiveFullFileName);
  XORKey:=$4E;
  for i:=1 to fArchive.TotalFiles do
  begin
    Extention:=UpperCase(Copy(fArchive.Items[i-1].Name,DelimiterLast(fArchive.Items[i-1].Name,'.')+1,3));
    if Extention='BMP' then
    begin
      FData.Seek(fArchive.Items[i-1].Offset,spBegin);
      SavePosition:=FData.Position;
      FData.Seek(SavePosition+$08,spBegin);
      FData.Read(XOR1,1);
      FData.Seek(SavePosition+$10,spBegin);
      FData.Read(XOR2,1);
      FData.Seek(SavePosition+$20,spBegin);
      FData.Read(XOR3,1);
      if (XOR1=XOR2)and(XOR2=XOR3) then
      begin
        XORKey:=XOR1;
        Break;
      end;
    end;
  end;
  if not(fBasePath[Length(fBasePath)]='\') then fBasePath:=fBasePath+'\';
  for i:=1 to fArchive.TotalFiles do
  begin
    if fArchive.Items[i-1].FlagExtract then
    begin
      fFilePath:=fBasePath+ExtractFilePath(fArchive.Items[i-1].Name);
      if not (DirectoryExists(fFilePath)) then MakeTree(fFilePath);
      FTemp:=NewWriteFileStream(fBasePath+fArchive.Items[i-1].Name);
      if fArchive.Items[i-1].FlagCompressed then
      begin
        FData.Seek(fArchive.Items[i-1].Offset,spBegin);
        TotalBlocks:=fArchive.Items[i-1].SizeReal div BlockSize;
        if TotalBlocks=0 then
        begin
          FData.Read(Buffer,fArchive.Items[i-1].SizeReal);
          for j:=1 to fArchive.Items[i-1].SizeReal do Buffer[j-1]:=Buffer[j-1] xor XORKey;
          FTemp.Write(Buffer,fArchive.Items[i-1].SizeReal);
        end else
        begin
          for z:=1 to TotalBlocks do
          begin
            FData.Read(Buffer,BlockSize);
            for j:=1 to BlockSize do Buffer[j-1]:=Buffer[j-1] xor XORKey;
            FTemp.Write(Buffer,BlockSize);
          end;
          if fArchive.Items[i-1].SizeReal-TotalBlocks*BlockSize>0 then
          begin
            FData.Read(Buffer,fArchive.Items[i-1].SizeReal-TotalBlocks*BlockSize);
            for j:=1 to fArchive.Items[i-1].SizeReal-TotalBlocks*BlockSize do Buffer[j-1]:=Buffer[j-1] xor XORKey;
            FTemp.Write(Buffer,fArchive.Items[i-1].SizeReal-TotalBlocks*BlockSize);
          end;
        end;
      end else
      begin
        FData.Seek(fArchive.Items[i-1].Offset,spBegin);
        Stream2Stream(FTemp,FData,fArchive.Items[i-1].SizeReal);
      end;
      FTemp.Free;
    end;
    fProgressBar.Progress:=Round(Int(100*(i/fArchive.TotalFiles)));
  end;
  fForm.Hide;
  FData.Free;
end;

exports
  GetPluginInfo,
  GetFileInfo,
  GetArchiveContent,
  GetFileAutoload,
  UnpackArchive,
  GetPluginID;

begin
end.
