library trafficgiant;

uses kol, data_classes_archive;

const
  FT_ARCHIVE=$0001;

  INFO_1='   ';

var
  FData,FTemp,FMem: PStream;

procedure GetPluginInfo(var Title,Version,GameName,FilterGroupName,Filters,Extentions,Comments: PChar);
begin
  Title:=PChar('Traffic Giant Plugin');
  Version:=PChar('v1.01');
  GameName:=PChar('Traffic Giant');
  FilterGroupName:=PChar('Traffic Giant (*.jfl)');
  Filters:=PChar('*.jfl');
  Extentions:=PChar('JFL');
  Comments:=PChar('  JFL');
end;

function GetFileInfo(fName: PChar): Word;
begin
  Result:=FT_ARCHIVE;
end;

// ID 
function GetPluginID: Integer;
begin
  Result:=$0002;
end;

function GetFileAutoload(fName: PChar): Boolean;
begin
  Result:=True;
end;

procedure GetArchiveContent(fName: PChar; var fArchive: TArchive; fForm,fLabel,fProgressBar: PControl);
var
  TotalFiles,i,j,fTemp,SavePosition: LongInt;
  c: Char;
  fStr,Extention: string;
  Found: Boolean;
begin
  fForm.Show;
  fLabel.Caption:=INFO_1+'(1/2)';
  fProgressBar.Progress:=0;
  fForm.Update;
  FData:=NewReadFileStream(fName);
  FData.Read(TotalFiles,4);
  Dec(TotalFiles);
  fArchive.TotalFiles:=TotalFiles;
  fArchive.ArchiveFullFileName:=string(fName);
  for i:=1 to TotalFiles do fArchive.Add('',0,0,0);
  fLabel.Caption:=INFO_1+'(2/2)';
  for i:=1 to TotalFiles do
  begin
    FData.Seek($04+(i-1)*216,spBegin);
    FData.Read(fTemp,4);
    fArchive.Items[i-1].Offset:=fTemp;
    FData.Seek($04,spCurrent);
    FData.Read(fTemp,4);
    fArchive.Items[i-1].SizeCompressed:=fTemp;
    FData.Read(fTemp,4);
    fArchive.Items[i-1].SizeReal:=fTemp;
    fStr:='';
    repeat
      FData.Read(c,1);
      if not (c=#$00) then fStr:=fStr+c;
    until c=#$00;
    Extention:=UpperCase(Copy(fStr,DelimiterLast(fStr,'.')+1,3));
    if fArchive.CountFilters=0 then
    begin
      fArchive.AddFilter('*.'+LowerCase(Extention),Extention);
      fArchive.Items[i-1].FilterIndex:=fArchive.CountFilters-1;
    end
    else
    begin
      Found:=False;
      for j:=1 to fArchive.CountFilters do if fArchive.Filters[j-1].Extention=Extention then
      begin
        Found:=True;
        fArchive.Items[i-1].FilterIndex:=j-1;
        Break;
      end;
      if not Found then
      begin
        fArchive.AddFilter('*.'+LowerCase(Extention),Extention);
        fArchive.Items[i-1].FilterIndex:=fArchive.CountFilters-1;
      end;
    end;
    fArchive.Items[i-1].Name:=fStr;
    fArchive.Items[i-1].FlagExtract:=False;
    fProgressBar.Progress:=Round(Int(100*(i/TotalFiles)));
  end;
  fArchive.FlagUseFilters:=True;
  FData.Free;
  fForm.Hide;
end;

procedure ExpandByte(B: Byte; var BT,BL: Byte);
begin
  BT:=B shr 7;
  BL:=B and $7F;
end;

procedure UnpackArchive(fName: PChar; fArchive: TArchive; var fForm,fLabel,fProgressBar: PControl);
var
  fBasePath,fFilePath: string;
  i: Integer;
  Buffer: array[0..255]of byte;
  B,BT,BL,Z: Byte;
begin
  if fArchive.TotalFiles=0 then Exit;
  fForm.Show;
  fLabel.Caption:=' ...';
  fProgressBar.Progress:=0;
  fForm.Update;
  fBasePath:=fName;
  FData:=NewReadFileStream(fArchive.ArchiveFullFileName);
  if not(fBasePath[Length(fBasePath)]='\') then fBasePath:=fBasePath+'\';
  for i:=1 to fArchive.TotalFiles do
  begin
    if fArchive.Items[i-1].FlagExtract then
    begin
      FData.Seek(fArchive.Items[i-1].Offset,spBegin);
      FTemp:=NewWriteFileStream(fBasePath+fArchive.Items[i-1].Name);
      FMem:=NewMemoryStream;
      repeat
        FData.Read(B,1);
        ExpandByte(B,BT,BL);
        case BT of
        1:begin
            FData.Read(Z,1);
            FillChar(Buffer,BL+3,z);
            FMem.Write(Buffer,BL+3);
          end;
        0:begin
            Stream2Stream(FMem,FData,BL);
          end;
        end;
      until FData.Position>=fArchive.Items[i-1].Offset+fArchive.Items[i-1].SizeCompressed;
      FMem.Seek(0,spBegin);
      Stream2Stream(FTemp,FMem,FMem.Size);
      FMem.Free;
      FTemp.Free;
    end;
    fProgressBar.Progress:=Round(Int(100*(i/fArchive.TotalFiles)));
  end;
  fForm.Hide;
  FData.Free;
end;

exports
  GetPluginInfo,
  GetFileInfo,
  GetArchiveContent,
  GetFileAutoload,
  UnpackArchive,
  GetPluginID;

begin
end.
